/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { FinalValueSelectionMode_$type } from "./FinalValueSelectionMode";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FinalValueLayerFrame } from "./FinalValueLayerFrame";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, enumGetBox, fromEnum, Point_$type, markType, markDep } from "igniteui-react-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-react-core";
/**
 * @hidden
 */
var FinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayer, _super);
    function FinalValueLayer() {
        var _this = _super.call(this) || this;
        _this.axisAnnotationFormatLabel = null;
        _this.w8 = null;
        _this.w7 = null;
        var a = new FinalValueLayerFrame();
        var b = new FinalValueLayerFrame();
        var c = new FinalValueLayerFrame();
        var d = _this.jj / 1000;
        _this.uh = a;
        _this.ug = b;
        _this.ui = c;
        _this.ab = FinalValueLayer.$;
        return _this;
    }
    FinalValueLayer.prototype.bc = function () {
        return new FinalValueLayer();
    };
    FinalValueLayer.prototype.get_d5 = function () {
        return true;
    };
    FinalValueLayer.prototype.cd = function () {
        return new FinalValueLayerView(this);
    };
    FinalValueLayer.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.w3 = a;
    };
    Object.defineProperty(FinalValueLayer.prototype, "yd", {
        get: function () {
            return new Thickness(1, this.xb, this.xd, this.xc, this.xa);
        },
        enumerable: false,
        configurable: true
    });
    FinalValueLayer.prototype.w6 = function () {
        return this.axisAnnotationFormatLabel != null;
    };
    FinalValueLayer.prototype.vu = function (a, b) {
        if (this.w5 == null || this.w5 == a) {
            if (!this.at.c) {
                this.pr(b);
            }
        }
    };
    FinalValueLayer.prototype.vw = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.vw.call(this, a, b);
        var c = a;
        c.f.clear();
        c.r.clear();
        c.q.clear();
        c.ac.clear();
        c.p.clear();
        c.ab.clear();
        c.h.clear();
        c.g.clear();
        c.i.clear();
        c.k.clear();
        c.m.clear();
        c.l.clear();
        c.j.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.s.clear();
        c.u.clear();
        c.w.clear();
        c.y.clear();
        c.x.clear();
        c.v.clear();
        c.z.clear();
        c.aa.clear();
        if (this.un(this.w5)) {
            this.xu(this.w5, c);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.cv.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (this.un(d)) {
                        this.xu(d, c);
                    }
                    if (d.isStacked) {
                        d.n6(function (e) {
                            if (_this.un(e)) {
                                _this.xu(e, c);
                            }
                            if (e.dw) {
                                e.n4(function (f) {
                                    if (_this.un(f)) {
                                        _this.xu(f, c);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (d.dw) {
                        d.n4(function (e) {
                            if (_this.un(e)) {
                                _this.xu(e, c);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    FinalValueLayer.prototype.un = function (a) {
        if (!_super.prototype.un.call(this, a)) {
            return false;
        }
        if (this.xr != null) {
            if (a.eq) {
                var b = a.lv();
                if (!Base.equalsStatic(this.xr, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.xr, a.name)) {
                    return false;
                }
            }
        }
        return true;
    };
    FinalValueLayer.prototype.oq = function () {
        _super.prototype.oq.call(this);
        if (!this.at.c && !this.dk()) {
            return;
        }
        if (this.dk()) {
            this.xv(this.ui, false);
        }
        else {
            this.xv(this.ug, false);
        }
    };
    FinalValueLayer.prototype.yc = function (a) {
        var b = NaN;
        var c = NaN;
        var d = this.w4;
        if (d == 0) {
            d = 1;
        }
        var e = false;
        if (d == 2) {
            e = true;
        }
        if (a.isVertical) {
            var f = a.as();
            if (f != null) {
                if (d == 1 || d == 2) {
                    var g = this.tq(this.cg);
                    if (f.ch) {
                        c = a.to({ $type: Point_$type, x: g.right, y: g.bottom }).y;
                    }
                    else {
                        c = a.to({ $type: Point_$type, x: g.right, y: g.top }).y;
                    }
                }
                else {
                    if (f.ch) {
                        c = 1;
                    }
                    else {
                        c = 0;
                    }
                }
            }
            return a.tj({ $type: Point_$type, x: 0, y: c }, e, true);
        }
        else {
            var h = a.as();
            if (h != null) {
                if (d == 1 || d == 2) {
                    var i = this.tq(this.cg);
                    if (h.ch) {
                        b = a.to({ $type: Point_$type, x: i.left, y: i.top }).x;
                    }
                    else {
                        b = a.to({ $type: Point_$type, x: i.right, y: i.top }).x;
                    }
                }
                else {
                    if (h.ch) {
                        b = 0;
                    }
                    else {
                        b = 1;
                    }
                }
            }
            if (a.el) {
                return a.tj({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
            else {
                return a.tj({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
        }
    };
    FinalValueLayer.prototype.xu = function (a, b) {
        var c = this.yc(a);
        var d = this.to(c);
        var e = this.su;
        if (e == null) {
            e = this.sy;
        }
        if (e == null) {
            e = a.su;
            if (e != null) {
                e = this.w3.b8(e);
            }
        }
        AxisAnnotationFrameManager.c(b, c, a, this.cv, this.getEffectiveViewport(), e, this.x9, this.w9, this.yb, this.ya, this.yd, this.xe, this.x9, this.w9, this.yb, this.ya, this.yd, this.xe, a.isVertical, !a.isVertical);
    };
    FinalValueLayer.prototype.xv = function (a, b) {
        var c = false;
        if (this.w7 == null) {
            c = true;
            this.w8 = new List$1(Axis.$, 0);
            this.w7 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.w7, this.w8, b, this.xf, this.xf, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
    };
    FinalValueLayer.prototype.vz = function (a, b) {
        _super.prototype.vz.call(this, a, b);
        if (this.dk()) {
            this.xv(this.ui, true);
        }
        else {
            this.xv(this.ug, false);
        }
    };
    FinalValueLayer.prototype.fn = function () {
        return true;
    };
    FinalValueLayer.prototype.pa = function (a, b, c, d) {
        var e_2, _a;
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case FinalValueLayer.$$p[11]:
            case FinalValueLayer.$$p[12]:
                this.pr(true);
                break;
            case FinalValueLayer.$$p[1]:
            case FinalValueLayer.$$p[0]:
            case FinalValueLayer.$$p[3]:
            case FinalValueLayer.$$p[5]:
            case FinalValueLayer.$$p[7]:
            case FinalValueLayer.$$p[6]:
            case FinalValueLayer.$$p[4]:
            case FinalValueLayer.$$p[8]:
            case FinalValueLayer.$$p[9]:
            case FinalValueLayer.$$p[10]:
                this.pr(true);
                break;
            case "SeriesViewer":
                var e = this.w8;
                var f = this.w7;
                if (f != null) {
                    var _loop_1 = function (g) {
                        var h = g.value;
                        h.c(function (i) { return g.key.an.remove(i); });
                        h.clear();
                    };
                    try {
                        for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var g = _c.value;
                            _loop_1(g);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    e.clear();
                    f.clear();
                }
                break;
        }
    };
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:w9:xw', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:x9:xx', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:xf:xy', [1, -1], 'AxisAnnotationOutline:ya:xz', [Brush.$, null], 'AxisAnnotationPaddingBottom:xa:x0', [1, NaN], 'AxisAnnotationPaddingLeft:xb:x1', [1, NaN], 'AxisAnnotationPaddingRight:xc:x2', [1, NaN], 'AxisAnnotationPaddingTop:xd:x3', [1, NaN], 'AxisAnnotationStrokeThickness:xe:x4', [1, NaN], 'AxisAnnotationTextColor:yb:x5', [Brush.$, null], 'FinalValueSelectionMode:w4:x6', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeriesName:xr:x7', [2, null], 'TargetSeries:w5:x8', [Series.$, null]]);
    return FinalValueLayer;
}(AnnotationLayer));
export { FinalValueLayer };
/**
 * @hidden
 */
var FinalValueLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayerView, _super);
    function FinalValueLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b7 = a;
        return _this;
    }
    FinalValueLayerView.prototype.au = function () {
        _super.prototype.au.call(this);
    };
    FinalValueLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, 0.1);
    };
    FinalValueLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
    };
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
}(AnnotationLayerView));
export { FinalValueLayerView };
